//
//  LJVRDebugEntry.m
//  vrsandbox
//
//  Created by 林飞阳 on 2021/9/17.
//

#import "LJVRDebugEntry.h"

#import <RSVRSDK/RSVRSDKConfig.h>
#import <RSVRSDK/RSVRSDk.h>
#import <RSVRSDK/RSVRShareBaseModel.h>

#import <Masonry/Masonry.h>
#import "LoginViewController.h"
#import "QiCodeScanningViewController.h"


static NSString *const DEFAULT_ANCHOR_URL = @"https://developers.realsee.com/docs/_media/live-demo/dist/?userRole=anchor";
static NSString *const DEFAULT_AUDIENCE_URL = @"https://developers.realsee.com/docs/_media/live-demo/dist/?userRole=audience";

@interface LJVRDebugEntry ()<RSVRSDKDelegate>

@property (nonatomic, strong) UILabel *iniLabel;
@property (nonatomic, strong) UILabel *appIdLabel;
@property (nonatomic, strong) UILabel *appSecretLabel;
@property (nonatomic, strong) UILabel *loginLabel;
@property (nonatomic, strong) UILabel *urlLabel;
@property (nonatomic, strong) UITextField *appIdInput;
@property (nonatomic, strong) UITextField *appSecretInput;
@property (nonatomic, strong) UITextView *urlInput;
@property (nonatomic, strong) UIButton *login;
@property (nonatomic, strong) UIButton *resetAnUrl;
@property (nonatomic, strong) UIButton *resetAuUrl;
@property (nonatomic, strong) UIButton *scanUrl;
@property (nonatomic, strong) UIButton *gotoVR;
@property (nonatomic, strong) UISwitch *debugSwitch;
@property (nonatomic, strong) UILabel *debugLabel;
@property (nonatomic, strong) UILabel *userIdLabel;
@property (nonatomic, strong) NSMutableArray *masonryViewArray;
@property (nonatomic,copy) dispatch_block_t loginBlockAction;


@end

@implementation LJVRDebugEntry

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = UIColor.whiteColor;
    self.navigationController.navigationBar.hidden = YES;
    [self setupUI];
    
//#if __has_include(<AmazonChimeSDK/AmazonChimeSDK-Swift.h>)
//    NSLog(@"DEBUGLOG [RSVRSDK] ===> AmazonChimeSDK");
//#endif
    
    self.appIdInput.text = @"1016";
    self.appSecretInput.text = @"123123";
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                                 selector:@selector(registerLoginCompletion:)
                                                     name:@"LoginCompletionNotification"
                                                   object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self
                                                 selector:@selector(scanUrlCompletion:)
                                                     name:@"ScanUrlCompletionNotification"
                                                   object:nil];
    
    
    [RSVRSDKConfig shareInstance].appInfo.scheme = @"com.sinoocean.mobile";
    [RSVRSDKConfig shareInstance].appInfo.userAgent = @"com.sinoocean.mobile/1.0";
    [RSVRSDKConfig shareInstance].userId = ^NSString * _Nullable{
        return @"b3xNG7yg5OS3JRw";
    };
    [RSVRSDKConfig shareInstance].userName = ^NSString * _Nullable{
        return @"18****20";
    };
    [RSVRSDKConfig shareInstance].accessToken = ^NSString * _Nullable{
        return @"YjN4Tkc3eWc1T1MzSlJ3aw==";
    };
    [RSVRSDKConfig shareInstance].appInfo.appId = @"bqknpNYaW7NdR4Bm";
    [RSVRSDKConfig shareInstance].appInfo.appSecret = @"2CEKSD36IWVKCORALY1ALR6SOMDYLJPZ";
    [RSVRSDKConfig shareInstance].configDelegate = self;
    RSVRSDKConfig.shareInstance.env = RSVRSDKEnvSandbox;
}

- (void)dealloc
{
    NSNotificationCenter *notificationCenter = [NSNotificationCenter defaultCenter];
    [notificationCenter removeObserver:self name:@"LoginCompletionNotification" object:nil];
    [notificationCenter removeObserver:self name:@"ScanUrlCompletionNotification" object:nil];
}

-(void)registerLoginCompletion:(NSNotification*)notification {
    NSString *userId = [[NSUserDefaults standardUserDefaults] valueForKey:@"login_user_id"];
    if (userId) {
        self.userIdLabel.text = [NSString stringWithFormat:@"%@", userId];
    }
    if (self.loginBlockAction) {
        self.loginBlockAction();
    }
}

-(void)scanUrlCompletion:(NSNotification*)notification {
    NSString* url = notification.object;
    self.urlInput.text = url;
}

- (void)didShareItemClick:(RSVRShareBaseModel *)shareModel; {
    NSLog(@"DEBUGLOG [RSVRSDK] ===> muji");
}

- (void)onActionRouter:(NSString *)router {
    NSLog(@"DEBUGLOG [RSVRSDK] ===> muji");
}

- (void)actionURL:(NSString *)urlString withFinishBlock:(RSVRSchemeFinishCallback _Nullable)finishBlock {
    if ([urlString containsString:@"/getToken"]) {
        finishBlock(@"3e0014cf-6390-9cad-bbd8-165f473f42e0");
    }
}

- (void)setupUI {
    [self.iniLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view).offset(20);
        make.height.mas_equalTo(30.0);
        make.top.equalTo(self.view).inset(CGRectGetHeight([[UIApplication sharedApplication] statusBarFrame]) + 32);
    }];
    
    [self.appIdLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.iniLabel);
        make.top.equalTo(self.iniLabel.mas_bottom).offset(10);
        make.width.mas_equalTo(50.0);
    }];
    
    
    [self.appIdInput mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.appIdLabel.mas_top);
        make.left.equalTo(self.appIdLabel.mas_right).offset(40);
        make.right.equalTo(self.view).offset(-20);
        make.height.mas_equalTo(30.0);
    }];
    [self.appSecretLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.iniLabel);
        make.top.equalTo(self.appIdInput.mas_bottom).offset(15);
    }];
    [self.appSecretInput mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.appSecretLabel.mas_top);
        make.left.equalTo(self.appIdInput);
        make.right.equalTo(self.view).offset(-20);
        make.height.mas_equalTo(30.0);
        
    }];
    
    [self.loginLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.width.equalTo(self.iniLabel);
        make.height.mas_equalTo(30.0);
        make.top.equalTo(self.appSecretInput.mas_bottom).offset(35.0);
    }];
    
    [self.userIdLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.loginLabel);
        make.right.equalTo(self.view).offset(-20);
        make.height.mas_equalTo(30.0);
        make.top.equalTo(self.loginLabel.mas_bottom).offset(10.f);
    }];
    
    [self.login mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.userIdLabel.mas_bottom).offset(10.0);
        make.left.equalTo(self.userIdLabel);
        make.right.equalTo(self.view).offset(-20);
    }];
    
    [self.urlLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.width.equalTo(self.iniLabel);
        make.top.equalTo(self.login.mas_bottom).offset(35.0);
    }];
    
    [self.urlInput mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.width.equalTo(self.iniLabel);
        make.height.mas_equalTo(120.0);
        make.right.equalTo(self.view).offset(-20);
        make.top.equalTo(self.urlLabel.mas_bottom).offset(10.0);
    }];
    
    // 实现masonry水平固定间隔方法
    [self.masonryViewArray mas_distributeViewsAlongAxis:MASAxisTypeHorizontal withFixedSpacing:10 leadSpacing:20 tailSpacing:20];
    // 设置array的垂直方向的约束
    [self.masonryViewArray mas_makeConstraints:^(MASConstraintMaker *make) {
        make.height.mas_equalTo(30.0);
        make.top.equalTo(self.urlInput.mas_bottom).offset(10.0);
    }];
    

    [self.debugLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.urlInput);
        make.height.mas_equalTo(32.0);
        make.top.equalTo(self.urlInput.mas_bottom).offset(65.0);
    }];
    [self.debugSwitch mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.debugLabel);
        make.left.equalTo(self.debugLabel.mas_right).offset(16.0);
    }];

    NSString *url = [[NSUserDefaults standardUserDefaults] stringForKey:@"debug_url"];
    if (!url || url.length == 0) url = DEFAULT_ANCHOR_URL;

    self.urlInput.text = url;
    self.debugSwitch.on = [self isDebugMode];
    NSString *userId = [[NSUserDefaults standardUserDefaults] valueForKey:@"login_user_id"];
    if (userId) {
        self.userIdLabel.text = [NSString stringWithFormat:@"%@", userId];
    }
}

-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    [self.view endEditing:YES];
}

# pragma mark Action

- (void)resetAnUrlAction {
    self.urlInput.text = DEFAULT_ANCHOR_URL;
}
- (void)resetAuUrlAction {
    self.urlInput.text = DEFAULT_AUDIENCE_URL;
}
- (void)scanUrlAction {
    QiCodeScanningViewController* qiCodeScanningViewController = [[QiCodeScanningViewController alloc] init];
    [self.navigationController pushViewController:qiCodeScanningViewController animated:YES];
}

- (void)gotoVRAction {
    [RSVRSDKConfig shareInstance].appInfo.appId = self.appIdInput.text;
    [RSVRSDKConfig shareInstance].appInfo.appSecret = self.appSecretInput.text;
    [RSVRSDKConfig shareInstance].appInfo.scheme = @"lianjiabeike";
    
    [[NSUserDefaults standardUserDefaults] setValue:self.urlInput.text forKey:@"debug_url"];
    NSString *url = self.urlInput.text;
//    NSString *url = [NSString stringWithFormat:@"https://vrlab-static.ljcdn.com/release/web/jsbridge/index.html?uuid=%f", [[NSDate date] timeIntervalSince1970]];
    RSVREntity *param = [[RSVREntity alloc] init];
    param.vrUrl = url;
//    param.vrUrl = @"https://realsee.js.org/live-demo/index.html?userRole=audience";
    param.loadingImage = [UIImage imageNamed:@"test"];
    param.loadingType = E_RSVRWebViewLoadingTypeTypeNone;
    UIViewController *vc = [RSVRSDK VRWebViewWithParam:param];
    [self.navigationController pushViewController:vc animated:YES];
}

- (void)debugModeChanged:(UISwitch *)sender {
    [[NSUserDefaults standardUserDefaults] setBool:sender.isOn forKey:@"vr_debug"];
}

- (void)loginAction {
    LoginViewController* loginVc = [[LoginViewController alloc] init];
    [self.navigationController pushViewController:loginVc animated:YES];
}

# pragma mark LJBNGlobalConfigProtocol

- (NSString *)ljbn_domain {
    return @"http://test1-ka.vr.demo.developer.realsee.com";
}

# pragma mark Private

- (BOOL)isDebugMode {
    return [[NSUserDefaults standardUserDefaults] boolForKey:@"vr_debug"];
}



# pragma mark Getter

- (UITextField *)inputWithPlacholder:(NSString *)placeholder {
    UITextField *input = [[UITextField alloc] init];
    input.placeholder = placeholder;
    input.layer.cornerRadius = 4.0;
    input.backgroundColor = UIColor.whiteColor;
    input.layer.masksToBounds = YES;
    input.layer.borderWidth = 1.0;
    input.layer.borderColor = UIColor.blackColor.CGColor;
    
    UIView *paddingView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 10, 10)];
    paddingView.backgroundColor = UIColor.whiteColor;
    input.leftView = paddingView;
    input.leftViewMode = UITextFieldViewModeAlways;
    
    return input;
}

- (UIButton *)buttonWithTitle:(NSString *)title {
    UIButton *button = [[UIButton alloc] init];
    [button setTitle:title forState:UIControlStateNormal];
    button.backgroundColor = [UIColor.blueColor colorWithAlphaComponent:0.8];
    button.titleLabel.font = [UIFont systemFontOfSize:14.0];
    return button;
}

- (UITextField *)appIdInput {
    if (!_appIdInput) {
        _appIdInput = [self inputWithPlacholder:@"appId"];
        [self.view addSubview:_appIdInput];
    }
    return _appIdInput;
}

- (UITextField *)appSecretInput {
    if (!_appSecretInput) {
        _appSecretInput = [self inputWithPlacholder:@"appSecret"];
        [self.view addSubview:_appSecretInput];
    }
    return _appSecretInput;
}

- (UITextView *)urlInput {
    if (!_urlInput) {
        _urlInput = [[UITextView alloc] init];
        _urlInput.layer.cornerRadius = 4.0;
        _urlInput.layer.masksToBounds = YES;
        _urlInput.layer.borderColor = UIColor.blackColor.CGColor;
        _urlInput.layer.borderWidth = 1.0;
        _urlInput.font = [UIFont systemFontOfSize:16];
        [self.view addSubview:_urlInput];
    }
    return _urlInput;
}

- (UIButton *)resetAnUrl {
    if (!_resetAnUrl) {
        _resetAnUrl = [self buttonWithTitle:@"默认主持人"];
        [_resetAnUrl addTarget:self action:@selector(resetAnUrlAction) forControlEvents:UIControlEventTouchUpInside];
        [self.view addSubview:_resetAnUrl];
    }
    return _resetAnUrl;
}

- (UIButton *)resetAuUrl {
    if (!_resetAuUrl) {
        _resetAuUrl = [self buttonWithTitle:@"默认观众"];
        [_resetAuUrl addTarget:self action:@selector(resetAuUrlAction) forControlEvents:UIControlEventTouchUpInside];
        [self.view addSubview:_resetAuUrl];
    }
    return _resetAuUrl;
}

- (UIButton *)scanUrl {
    if (!_scanUrl) {
        _scanUrl = [self buttonWithTitle:@"扫码URL"];
        [_scanUrl addTarget:self action:@selector(scanUrlAction) forControlEvents:UIControlEventTouchUpInside];
        [self.view addSubview:_scanUrl];
    }
    return _scanUrl;
}

- (UIButton *)gotoVR {
    if (!_gotoVR) {
        _gotoVR = [self buttonWithTitle:@"进入测试"];
        [_gotoVR addTarget:self action:@selector(gotoVRAction) forControlEvents:UIControlEventTouchUpInside];
        [self.view addSubview:_gotoVR];
    }
    return _gotoVR;
}

- (NSMutableArray *)masonryViewArray {
    if (!_masonryViewArray) {
        _masonryViewArray = [NSMutableArray array];
        [_masonryViewArray addObject:self.resetAnUrl];
        [_masonryViewArray addObject:self.resetAuUrl];
        [_masonryViewArray addObject:self.scanUrl];
        [_masonryViewArray addObject:self.gotoVR];
    }
    
    return _masonryViewArray;
}

- (UIButton *)login {
    if (!_login) {
        _login = [self buttonWithTitle:@"跳转到登录页"];
        [_login addTarget:self action:@selector(loginAction) forControlEvents:UIControlEventTouchUpInside];
        [self.view addSubview:_login];
    }
    return _login;
}

- (UILabel *)userIdLabel {
    if (!_userIdLabel) {
        _userIdLabel = [[UILabel alloc] init];
        _userIdLabel.textColor = UIColor.blackColor;
        _userIdLabel.backgroundColor = UIColor.lightGrayColor;
        _userIdLabel.font = [UIFont systemFontOfSize:18.0];
        [self.view addSubview:_userIdLabel];
    }
    return _userIdLabel;
}

- (UILabel *)iniLabel {
    if (!_iniLabel) {
        _iniLabel = [[UILabel alloc] init];
        _iniLabel.textColor = UIColor.blackColor;
        _iniLabel.font = [UIFont systemFontOfSize:18.0];
        _iniLabel.text = @"初始化配置";
        [self.view addSubview:_iniLabel];
    }
    return _iniLabel;
}

- (UILabel *)loginLabel {
    if (!_loginLabel) {
        _loginLabel = [[UILabel alloc] init];
        _loginLabel.textColor = UIColor.blackColor;
        _loginLabel.font = [UIFont systemFontOfSize:18.0];
        _loginLabel.text = @"userID";
        [self.view addSubview:_loginLabel];
    }
    return _loginLabel;
}

- (UILabel *)appIdLabel {
    if (!_appIdLabel) {
        _appIdLabel = [[UILabel alloc] init];
        _appIdLabel.textColor = UIColor.blackColor;
        _appIdLabel.font = [UIFont systemFontOfSize:16.0];
        _appIdLabel.text = @"appId";
        [self.view addSubview:_appIdLabel];
    }
    return _appIdLabel;
}

- (UILabel *)appSecretLabel {
    if (!_appSecretLabel) {
        _appSecretLabel = [[UILabel alloc] init];
        _appSecretLabel.textColor = UIColor.blackColor;
        _appSecretLabel.font = [UIFont systemFontOfSize:16.0];
        _appSecretLabel.text = @"appSecret";
        [self.view addSubview:_appSecretLabel];
    }
    return _appSecretLabel;
}

- (UILabel *)urlLabel {
    if (!_urlLabel) {
        _urlLabel = [[UILabel alloc] init];
        _urlLabel.textColor = UIColor.blackColor;
        _urlLabel.font = [UIFont systemFontOfSize:18.0];
        _urlLabel.text = @"VR Url";
        [self.view addSubview:_urlLabel];
    }
    return _urlLabel;
}



- (UILabel *)debugLabel {
    if (!_debugLabel) {
        _debugLabel = [[UILabel alloc] init];
        _debugLabel.font = [UIFont systemFontOfSize:16.0];
        _debugLabel.textColor = UIColor.blackColor;
        _debugLabel.text = @"Debug环境";
        [self.view addSubview:_debugLabel];
    }
    return _debugLabel;
}

- (UISwitch *)debugSwitch {
    if (!_debugSwitch) {
        _debugSwitch = [[UISwitch alloc] init];
        [_debugSwitch addTarget:self action:@selector(debugModeChanged:) forControlEvents:UIControlEventValueChanged];
        [self.view addSubview:_debugSwitch];
    }
    return _debugSwitch;
}

#pragma RSVRSDkDelegate
/// H5 页面点击分享时调用
/// @param param  H5 页面传过来的分享参数
//- (void)shareWithParam:(NSDictionary *)param
//{
//    
//}

/// VR webview 内有一些页面需要登录才可以进入,
/// 需要在这个代理方法里面实现唤起登录界面.
/// @param didUserLoginBlock 当用户登录成功之后, 你需要主动调用这个 block
- (void)actionLogin:(dispatch_block_t)didUserLoginBlock
{
    self.loginBlockAction = didUserLoginBlock;
    LoginViewController* loginVc = [[LoginViewController alloc] init];
    [self.navigationController pushViewController:loginVc animated:YES];
}

@end
