//
//  ViewController.m
//  vrdemo
//
//  Created by 如视VR on 2021/11/25.
//

#import "LoginViewController.h"
#import <Masonry/Masonry.h>
#import "AFNetworking/AFNetworking.h"
#import "SVProgressHUD.h"

@interface LoginViewController ()
@property (nonatomic, strong) UILabel *userIdLabel;
@property (nonatomic, strong) UILabel *userNameLabel;
@property (nonatomic, strong) UILabel *userIdResult;
@property (nonatomic, strong) UILabel *userNameResult;
@property (nonatomic, strong) UILabel *tokenLabel;
@property (nonatomic, strong) UILabel *tokenResult;
@property (nonatomic, strong) UIButton *login;

@end

@implementation LoginViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    [self setupUI];
    self.userIdResult.text = [NSString stringWithFormat:@"%@", [[NSUserDefaults standardUserDefaults] valueForKey:@"login_user_id"]];
    self.userNameResult.text = [NSString stringWithFormat:@"%@", [[NSUserDefaults standardUserDefaults] valueForKey:@"login_name"]];
    self.tokenResult.text = [NSString stringWithFormat:@"%@", [[NSUserDefaults standardUserDefaults] valueForKey:@"login_token"]];
}


- (void)setupUI {
    [self.userIdLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view).offset(20);
        make.height.mas_equalTo(30.0);
        make.width.mas_equalTo(90);
        make.top.equalTo(self.view).offset(200);
    }];
    
    [self.userIdResult mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.userIdLabel.mas_right).offset(20);
        make.height.mas_equalTo(30.0);
        make.top.equalTo(self.userIdLabel);
    }];
    
    [self.userNameLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view).offset(20);
        make.height.mas_equalTo(30.0);
        make.width.mas_equalTo(90);
        make.top.equalTo(self.userIdLabel.mas_bottom).offset(10);
    }];
    
    [self.userNameResult mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.userNameLabel.mas_right).offset(20);
        make.height.mas_equalTo(30.0);
        make.top.equalTo(self.userNameLabel);
        make.right.equalTo(self.view).offset(-20);
    }];
    
    [self.tokenLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view).offset(20);
        make.height.mas_equalTo(30.0);
        make.width.mas_equalTo(90);
        make.top.equalTo(self.userNameLabel.mas_bottom).offset(10);
    }];
    
    [self.tokenResult mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.tokenLabel.mas_right).offset(20);
        make.height.mas_equalTo(30.0);
        make.top.equalTo(self.tokenLabel);
        make.right.equalTo(self.view).offset(-20);
    }];
    
    [self.login mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.tokenLabel);
        make.height.mas_equalTo(30.0);
        make.top.equalTo(self.tokenLabel.mas_bottom).offset(10);
        make.right.equalTo(self.view).offset(-20);
    }];
    
    
    
    
}

- (UILabel *)userIdLabel {
    if (!_userIdLabel) {
        _userIdLabel = [[UILabel alloc] init];
        _userIdLabel.font = [UIFont systemFontOfSize:16.0];
        _userIdLabel.textColor = UIColor.blackColor;
        _userIdLabel.text = @"UserId";
        [self.view addSubview:_userIdLabel];
    }
    return _userIdLabel;
}

- (UILabel *)userNameLabel {
    if (!_userNameLabel) {
        _userNameLabel = [[UILabel alloc] init];
        _userNameLabel.font = [UIFont systemFontOfSize:16.0];
        _userNameLabel.textColor = UIColor.blackColor;
        _userNameLabel.text = @"UserName";
        [self.view addSubview:_userNameLabel];
    }
    return _userNameLabel;
}

- (UILabel *)userNameResult {
    if (!_userNameResult) {
        _userNameResult = [[UILabel alloc] init];
        _userNameResult.font = [UIFont systemFontOfSize:16.0];
        _userNameResult.textColor = UIColor.blackColor;
        [self.view addSubview:_userNameResult];
    }
    return _userNameResult;
}

- (UILabel *)tokenLabel {
    if (!_tokenLabel) {
        _tokenLabel = [[UILabel alloc] init];
        _tokenLabel.font = [UIFont systemFontOfSize:16.0];
        _tokenLabel.textColor = UIColor.blackColor;
        _tokenLabel.text = @"Token";
        [self.view addSubview:_tokenLabel];
    }
    return _tokenLabel;
}

- (UILabel *)tokenResult {
    if (!_tokenResult) {
        _tokenResult = [[UILabel alloc] init];
        _tokenResult.font = [UIFont systemFontOfSize:16.0];
        _tokenResult.textColor = UIColor.blackColor;
        [self.view addSubview:_tokenResult];
    }
    return _tokenResult;
}


- (UILabel *)userIdResult {
    if (!_userIdResult) {
        _userIdResult = [[UILabel alloc] init];
        _userIdResult.font = [UIFont systemFontOfSize:16.0];
        _userIdResult.textColor = UIColor.blackColor;
        [self.view addSubview:_userIdResult];
    }
    return _userIdResult;
}

- (UIButton *)login {
    if (!_login) {
        _login = [self buttonWithTitle:@"登录并获取userID"];
        [_login addTarget:self action:@selector(loginAction) forControlEvents:UIControlEventTouchUpInside];
        [self.view addSubview:_login];
    }
    return _login;
}

- (UIButton *)buttonWithTitle:(NSString *)title {
    UIButton *button = [[UIButton alloc] init];
    [button setTitle:title forState:UIControlStateNormal];
    button.backgroundColor = [UIColor.blueColor colorWithAlphaComponent:0.8];
    button.titleLabel.font = [UIFont systemFontOfSize:14.0];
    return button;
}


- (void)loginAction {
    __weak typeof(self) wself = self;
    [self getUserInfoWithCompletion:^{
        __strong typeof(wself) self = wself;
        self.userIdResult.text = [NSString stringWithFormat:@"%@", [[NSUserDefaults standardUserDefaults] valueForKey:@"login_user_id"]];
        self.userNameResult.text = [NSString stringWithFormat:@"%@", [[NSUserDefaults standardUserDefaults] valueForKey:@"login_name"]];
        self.tokenResult.text = [NSString stringWithFormat:@"%@", [[NSUserDefaults standardUserDefaults] valueForKey:@"login_token"]];
        [[NSNotificationCenter defaultCenter]
           postNotificationName:@"LoginCompletionNotification"
           object:nil
           userInfo:nil];
        
        [self.navigationController popViewControllerAnimated:YES];
        
    }];
}

- (void)getUserInfoWithCompletion:(dispatch_block_t)completion {
    NSString *url = @"http://test1-ka.vr.demo.developer.realsee.com/demo/auth/login";
    
    AFHTTPSessionManager *manager = [AFHTTPSessionManager manager];
    manager.responseSerializer = [AFHTTPResponseSerializer serializer];
    // 设置超时时间
    [manager.requestSerializer willChangeValueForKey:@"timeoutInterval"];
    manager.requestSerializer.timeoutInterval = 150.0f;
    [manager.requestSerializer didChangeValueForKey:@"timeoutInterval"];
    
    [manager GET:url parameters:nil headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable data) {
        
        NSString *receiveStr = [[NSString alloc]initWithData:data encoding:NSUTF8StringEncoding];
        NSData * datas = [receiveStr dataUsingEncoding:NSUTF8StringEncoding];
        NSDictionary *responseObject = [NSJSONSerialization JSONObjectWithData:datas options:NSJSONReadingMutableLeaves error:nil];
        
        
        NSInteger code = [[responseObject objectForKey:@"code"] integerValue];
        if (code != 0) {
            NSLog(@"net fail code= %ld",code);
            [SVProgressHUD showErrorWithStatus:[NSString stringWithFormat:@"请求失败：%ld",code]];
            return;
        }
        [[NSUserDefaults standardUserDefaults] setValue:[responseObject valueForKeyPath:@"data.nickname"] forKey:@"login_name"];
        [[NSUserDefaults standardUserDefaults] setValue:[responseObject valueForKeyPath:@"data.token"] forKey:@"login_token"];
        [[NSUserDefaults standardUserDefaults] setValue:[responseObject valueForKeyPath:@"data.user_id"] forKey:@"login_user_id"];
        [SVProgressHUD showSuccessWithStatus:@"请求成功"];
        if (completion) completion();
        
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        NSLog(@"net fail ~ %@",error.localizedDescription);
        [SVProgressHUD showErrorWithStatus:[NSString stringWithFormat:@"请求失败：%@",error.localizedDescription]];
        if (completion) completion();
    }];
}




@end
